package TP1;


import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

public class TestParamsServlet extends HttpServlet {

	
	private static Logger _log = null;
	
	
	public void init() throws ServletException {
		
		//get the path to the loggerPropertie file inside the servlet
	    String loggerProperties = this.getServletContext().getInitParameter("loggerProperties");
		loggerProperties = getServletContext().getRealPath("/") + loggerProperties;
		//load the configuration for this application's loggers using the
		// servletLog.properties file
		PropertyConfigurator.configure(loggerProperties);
		//create the logger for this servlet class
		//it will use the configuration for the logger com.java2s.LoggerServlet
		//or inherit from the logger com.java2s if one exists, and so on
		_log = Logger.getLogger(this.getClass());


		_log.info(this.getClass().getName()+" started.");
		 //display a DEBUG level message
	    _log.debug("Sending a DEBUG message");
	    //display an INFO level message
	    _log.info("Sending an INFO message");
	    //display an ERROR level message
	    _log.error("Sending an ERROR message");

	}

	public void destroy() {

	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
	   
		response.setContentType("text/html");
		PrintWriter pw = response.getWriter();
		pw.print("<html>");
		pw.print("<body bgcolor=\"white\">");
		pw.print("<head>");
		pw.print("<title>Une servlet plus �volu�e</title>");
		pw.print("</head>");
		pw.print("<body>");
		String sessionID = request.getSession().getId();
		pw.print("<h1>La session</h1>");
		pw.println("<h2>session id :"+sessionID+"</h2>");

		pw.print("<h1>Liste des param�etres de requ�ete</h1>");
		
		Enumeration e = request.getParameterNames();
		while (e.hasMoreElements()){
			String param = e.nextElement().toString();
			pw.println("<h3>"+param+" = "+request.getParameter(param)+"</h3>");
		}
		
		pw.print("<h1>Liste des param�etres d'initialisation</h1>");
		pw.print("<table border=\"1\">");

		Enumeration pInit = request.getSession().getServletContext().getInitParameterNames();
		while (pInit.hasMoreElements()){
			String param = pInit.nextElement().toString();
			pw.println("<tr><td>"+param+" </td><td> "+request.getSession().getServletContext().getInitParameter(param)+"</td></tr>");
		}
		pw.print("</table>");

		pw.print("<h1>Liste des headers</h1>");
		pw.print("<table border=\"1\">");
		Enumeration headers = request.getHeaderNames();
		while (headers.hasMoreElements()){
			String param = headers.nextElement().toString();
			pw.println("<tr><td>"+param+" </td><td> "+request.getHeader(param)+"</td></tr>");
		}
		pw.print("</table>");
		
		pw.print("<h1>D�etails de la requ�te</h1>");
		pw.print("<table border=\"1\">");
		String contextPath = request.getContextPath();
		
		String contentType = request.getContentType();
		String pathInfo = request.getPathInfo();
		String pathTranslated = request.getPathTranslated();
		String protocol = request.getProtocol();
		String queryString = request.getQueryString();
		String realPathIndex = request.getRealPath("test.html");
		String uri = request.getRequestURI();
		String serverName = request.getServerName();
		int serverPort = request.getServerPort();
		String servletPath = request.getServletPath();
		
		pw.print("<tr><td>"+"protocol"+"</td><td>"+protocol+"</td></tr>");
		pw.print("<tr><td>"+"serverName"+"</td><td>"+serverName+"</td></tr>");
		pw.print("<tr><td>"+"serverPort"+"</td><td>"+serverPort+"</td></tr>");
		pw.print("<tr><td>"+"contextPath"+"</td><td>"+contextPath+"</td></tr>");
		pw.print("<tr><td>"+"servletPath"+"</td><td>"+servletPath+"</td></tr>");
		pw.print("<tr><td>"+"uri"+"</td><td>"+uri+"</td></tr>");
		pw.print("<tr><td>"+"queryString"+"</td><td>"+queryString+"</td></tr>");

		pw.print("<tr><td>"+"Chemin sur le FS du fichier test.html"+"</td><td>"+realPathIndex+"</td></tr>");

		pw.print("<tr><td>"+"contentType"+"</td><td>"+contentType+"</td></tr>");
		Cookie[] cookies = request.getCookies();
		if (cookies != null) {
			for (int i=0; i<cookies.length; i++){
				pw.print("<tr><td>"+"cookie "+i+"</td><td>"+cookies[i]+"</td></tr>");
			}
		}
		pw.print("<tr><td>"+"pathInfo"+"</td><td>"+pathInfo+"</td></tr>");
		pw.print("<tr><td>"+"pathTranslated"+"</td><td>"+pathTranslated+"</td></tr>");


		pw.print("</table>");
		
		pw.print("<h1>Locally, the servlet is running</h1>");
		pw.print("<table>");
		String localAddr = request.getLocalAddr();
		pw.print("<tr><td>"+"localAddr"+"</td><td>"+localAddr+"</td></tr>");
		String localName = request.getLocalName();
		pw.print("<tr><td>"+"localName"+"</td><td>"+localName+"</td></tr>");
		int localPort = request.getLocalPort();
		pw.print("<tr><td>"+"localPort"+"</td><td>"+localPort+"</td></tr>");
		pw.print("</table>");
		
		
		
		pw.print("<h1>Remote, the user is coming from </h1>");
		pw.print("<table>");
		String remoteAddr = request.getRemoteAddr();
		pw.print("<tr><td>"+"remoteAddr"+"</td><td>"+remoteAddr+"</td></tr>");
		String remoteHost = request.getRemoteHost();
		pw.print("<tr><td>"+"remoteHost"+"</td><td>"+remoteHost+"</td></tr>");
		int remotePort = request.getRemotePort();
		pw.print("<tr><td>"+"remotePort"+"</td><td>"+remotePort+"</td></tr>");
		String remoteUser = request.getRemoteUser();
		pw.print("<tr><td>"+"remoteUser"+"</td><td>"+remoteUser+"</td></tr>");
		
		pw.print("</table>");
		pw.print("<br/>");
		pw.print("<table>");
		pw.print("<tr><form method=\"post\" action=\"test.html\" enctype=\"text/plain\">");
		pw.print("<input type=\"submit\" onclick=\"submit\" onfocus=\"this.blur()\" value=\"Back\"/>");
		pw.print("</form>");
		pw.print("</tr></table>");
		pw.print("</body>");
		pw.println("</html>");
	
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
		doGet(request, response);
	}

	


	
	
	

}
